//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "FileManDlgs.h"
#include "FileMan.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TFileManDlg *FileManDlg;
//---------------------------------------------------------------------------
void __fastcall FileManErrorBox(AnsiString &Message, AnsiString &Title,
   TStrings *Status)
{
   FileManDlg = new TFileManDlg(Owner);
   FileManDlg->Caption = Title;
   FileManDlg->Msg->Lines->Add(Message);
   for (int i=0; i<Status->Count; i++)
      FileManDlg->Msg->Lines->Add(GetErrorMessage((int)Status->Objects[i]));
   MessageBeep(0);
   FileManDlg->ShowModal();
   delete FileManDlg;
}
//---------------------------------------------------------------------------
__fastcall TFileManDlg::TFileManDlg(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
AnsiString __fastcall GetErrorMessage(int ErrNo)
{
   switch (ErrNo)
   {
      case DB_OK: "All is well!"; break;

      case DB_OPENDBEXC: return "Error opening database";
      case DB_INITVIRGINDBERR: return "Error creating database";
      case DB_INITEXISTDBERR: return "Error initializing database";
      case DB_INVALIDHEADERR: return "Invalid database header";

      case DB_NODBERR: return "File not found";
      case DB_SEEKERR:
      case DB_SEEKEXC: return "Data seek error";
      case DB_READERR:
      case DB_READEXC: return "Data read error";
      case DB_WRITEERR:
      case DB_WRITEEXC: return "Data write error";

      case DB_READHEADERR:
      case DB_READHEADEXC:
      case DB_WRITEHEADERR:
      case DB_WRITEHEADEXC: return "Database header error";

      case DB_READSODERR:
      case DB_READSODEXC:
      case DB_WRITESODERR:
      case DB_WRITESODEXC: return "Database start-of-data error";

      case DB_READFREEERR:
      case DB_READFREEEXC:
      case DB_WRITEFREEERR:
      case DB_WRITEFREEEXC:
      case DB_WRITEALLOCENDERR:
      case DB_WRITEALLOCSODERR:
      case DB_ALLOCFREEERR:
      case DB_ALLOCFREEEXC:
      case DB_ADDFREEWRITEERR:
      case DB_ADDFREEENTERERR:
      case DB_WRITEALLOCFREEERR: return "Freelist allocation error";
      case DB_DEALOCREADFREEERR:
      case DB_DEALLOCFREEERR: return "Freelist deallocation error";

      case DB_WRITEALLOCERR:
      case DB_ALLOCERR:
      case DB_ALLOCEXC:
      case DB_ALLOCATENDEXC: return "Data allocation error";
      case DB_DEALOCREADSORERR: return "Data de-allocation error";

      case DB_GETBINARYERR:
      case DB_GETBINALLOCEXC: return "Error loading program data from disk";
      case DB_PUTBINARYERR: return "Error saving program data to disk";

      case DB_OPENINDEXERR:
      case DB_OPENINDEXEXC:
      case DB_ALLOCINDEXEXC: return "Error opening database index";

      case DB_WRITEINDEXERR:
      case DB_WRITEINDEXOFSERR: return "Error storing database index";
      case DB_INITINDEXERR: "Error initializing database index";

      case DB_GETDATSIZEERR: return "Error getting data size";
      case DB_GETDATTYPEERR: return "Error getting data type";
      case DB_BADBUFERR: return "Initialization of data buffer failed";

      case DB_ZIPDEFLERR:
      case DB_ZIPINFLERR: return "Error processing program data";
      default: return "Unknown file manager error!";
   }
   return "";
}
//---------------------------------------------------------------------------