//---------------------------------------------------------------------------
#ifndef Fileman1H
#define Fileman1H

#include "Global.h"
//---------------------------------------------------------------------------
#define FLNIL -1L

// header = 38 chars
// "BS\150\209\200\194\254\228\178\139\204\182"
// "qs\002\009\002\004\000\008\000\007\002\002\000\000\001\001\001\002\005"
//   "\150\209\200\194\254\228\178\139\204\182
#define FILEHEADER     "qsdb1xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\n"
#define FILEHEADE1     "bsdbxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\n"

// TFileManager errors
#define FM_OK   	  0
#define FM_OPENERR    1
#define FM_READERR	  2
#define FM_WRITEERR	  3
#define FM_ALLOCERR   4
#define FM_SEEKERR	  5
#define FM_HEADERR    6
#define FM_INITERR    7
#define FM_FREEERR    8     // freelist

// TFreeList errors
#define FL_OK         0
#define FL_OPENERR    1
#define FL_READERR    2
#define FL_WRITEERR   3
#define FL_ALLOCERR   4

// TDataBuf errors
#define FB_OK         0
#define FB_OPENERR    1
#define FB_READERR    2
#define FB_WRITEERR	  3
#define FB_ALLOCERR   4
#define FB_ENCRERR    5
#define FB_DECRERR    6
#define FB_ZIPERR     7

const int DBUF_OPENERR = 2;
const int DBUF_READERR = 3;

#define AppDatFile AnsiString(AppDat)

#define PS AnsiString("\xff")

#define INTSIZE sizeof(int)
#define PTRSIZE sizeof(void*)
#define OFSSIZE sizeof(TFLoffset)
#define SPCSIZE sizeof(TFLspace)
#define TYPSIZE 4

class TBUFFER : public TMemoryStream
{
   void  __fastcall SetPosition(long pos);
   long  __fastcall GetPosition();
   byte* __fastcall GetMemory();
   long  __fastcall GetSize();
public:
   AnsiString filename;
   // construct and destruct
   virtual __fastcall TBUFFER();
   virtual __fastcall TBUFFER(AnsiString Filename);
   virtual __fastcall~TBUFFER();
   // properties
   __property long ptr              = { read=GetPosition, write=SetPosition };
   __property byte *data            = { read=GetMemory }; // points to data as byte*
   __property char *chrs            = { read=GetMemory }; // points to data as char*
   __property long length           = { read=GetSize };
   // methods
   void __fastcall rewind();
   void __fastcall clear();
   bool __fastcall save();
   // convenience
   virtual byte __fastcall readbyte();
   virtual int  __fastcall readint();
   virtual long __fastcall readlong();
   virtual int  __fastcall writebyte(byte b);
   virtual int  __fastcall writeint(int i);
   virtual int  __fastcall writelong(long l);

   virtual byte __fastcall ReadByte();
   virtual int  __fastcall ReadInt();
   virtual long __fastcall ReadLong();
   virtual int  __fastcall WriteByte(byte b);
   virtual int  __fastcall WriteInt(int i);
   virtual int  __fastcall WriteLong(long l);
};

const char CLEARTEXT = 0;
const char COMPRESSED = 1;
const char ENCRYPTED = 2;
const char ISINDEX = 1;
const char ISDATA = 2;

typedef long TFLoffset;
typedef long TFLspace;
const TFLspace sizeofHeader = SPCSIZE;

class TDataBuf : public TObject {
public:
   int status;
   char* data;
   bool sensitive;
   char type[TYPSIZE];
   TFLspace length,orglength;
   virtual __fastcall TDataBuf(const AnsiString &Data);
   virtual __fastcall TDataBuf(const char *Data=NULL, TFLspace Length=0);
   __fastcall ~TDataBuf();
   bool __fastcall LoadFromFile(const AnsiString &Filename);
   bool __fastcall SaveToFile(const AnsiString &Filename);
   void __fastcall SetData(const char *Data, TFLspace Length); // sets 'data' and 'length' only
   void __fastcall Set(const char *Data, TFLspace Length);     // resets all
   int  __fastcall Encrypt(const AnsiString &password);
   int  __fastcall Decrypt(const AnsiString &password);
   bool __fastcall Encrypted();
   bool __fastcall Compressed();
   int  __fastcall Compress();
   int  __fastcall Decompress();
   bool __fastcall IsIndex();
   bool __fastcall IsData();
   bool __fastcall IsEmpty();
   void __fastcall Clear();
//   void __fastcall ClearData();
   AnsiString __fastcall str();
   char* __fastcall c_str();
};

typedef TDataBuf TFileBuf;
typedef TDataBuf TBuffer;

AnsiString __fastcall GetAppIni(AnsiString &key, AnsiString &defvalue, AnsiString &datafile=AppDatFile);
int __fastcall PutAppIni(AnsiString &key, AnsiString &Value, AnsiString &datafile=AppDatFile);
int __fastcall PutAppData(AnsiString &path, TStrings *items, AnsiString &datafile=AppDatFile);
int __fastcall GetAppData(TStrings *items, AnsiString &path, AnsiString &datafile=AppDatFile);
int __fastcall GetAppDataMainIndex(TStrings *items, AnsiString &datafile=AppDatFile);
int __fastcall GetAppBinary(AnsiString &path, TDataBuf *buf, AnsiString &datafile=AppDatFile);
int __fastcall PutAppBinary(AnsiString &path, TDataBuf *buf, AnsiString &datafile=AppDatFile);
int __fastcall PutAppBinaryData(AnsiString &path, char *data, int length, AnsiString &datafile=AppDatFile);
bool __fastcall AppDataExists(AnsiString &path, TStrings *data=NULL, AnsiString &datafile=AppDatFile);
bool __fastcall AppBinaryExists(AnsiString &path, TDataBuf *data=NULL, AnsiString &datafile=AppDatFile);
int __fastcall RenameAppIndex(AnsiString &Path, AnsiString &Newname, AnsiString &datafile=AppDatFile);
int __fastcall RenameAppItem(AnsiString &Path, AnsiString &Newname, AnsiString &datafile=AppDatFile);

class TFreeList : public TObject {
private:
   TList *offset;
   TList *space;
public:
   TFLoffset lastOffset; // assigned but not used
   TFLspace lastSpace;   //    ""    ""  ""   ""
   __fastcall TFreeList();
   __fastcall ~TFreeList();
   bool __fastcall AddFreeSpace(TFLoffset, TFLspace);
   TFLoffset __fastcall Allocate(TFLspace);
   void __fastcall AttemptMerge(int);
   bool __fastcall Coalesce(TFLoffset, TFLspace);
   bool __fastcall EnterFreeSpace(TFLoffset, TFLspace);
   TFLoffset __fastcall getOffset(int i) { return (TFLoffset)offset->Items[i]; }
   TFLspace __fastcall getSpace(int i) { return (TFLspace)space->Items[i]; }
   bool __fastcall LoadFromStream(TStream *);
   bool __fastcall SaveToStream(TStream *);
   int __fastcall Count();
};

class TFileManager : public TObject {
private:
  TStream *stream;
  TFreeList *freeList;	    // Free list block in memory.
  TFLoffset startOfData;	// Offset to first data in file.
  TFLoffset endOfData;		// Offset to last data in file.
  bool delStream;
public:
  bool failed;
  int status,block;
  AnsiString filename;
  __fastcall virtual TFileManager(const AnsiString &Filename);
  __fastcall virtual TFileManager(TStream *Stream);
  __fastcall ~TFileManager();
  void __fastcall Init(); // does all construction except stream
  TFLoffset __fastcall start() const { return startOfData; }
  TFLoffset __fastcall endData() const  { return endOfData; }

  TFLoffset __fastcall Allocate(TFLspace spc);
  TFLoffset __fastcall AllocateInFreeList(TFLspace spc);
  TFLoffset __fastcall AllocateAtEnd(TFLspace spc);
  void __fastcall Deallocate(TFLoffset ofs);

  bool __fastcall WriteFreeList();
  bool __fastcall ReadFreeList();
  bool __fastcall AddToFreeList(TFLoffset ofs, TFLspace space);

  bool __fastcall SeekTo(const TFLoffset ofs);
  bool __fastcall WriteDat(const void *data, long size);
  bool __fastcall WriteHeader();
  bool __fastcall WriteStartAndEnd();

  bool __fastcall ReadStartAndEnd();
  bool __fastcall ReadHeader();
  bool __fastcall ReadDat(void *data, long size);

  void __fastcall ChkFileManagerErr();
};

class TFMindex : public TStringList {
public:
   AnsiString name;
   TFLoffset offset;
   TFMindex *parent;
   TFileManager *fm;
   virtual __fastcall TFMindex(TFileManager *Fm, AnsiString Name="", TFMindex *Parent=NULL);
   TFLoffset __fastcall Save();
   void __fastcall ShowIndex();
   char __fastcall GetType(AnsiString &key);
   TFLspace  __fastcall GetSize(AnsiString &key);
   TFLoffset __fastcall GetOffset(AnsiString &key);
   TFLoffset __fastcall SetOffset(AnsiString &key, TFLoffset Offset); // <-not to disk
   TFLoffset __fastcall PutOffset(AnsiString &key, TFLoffset Offset); // <-to disk
   char* __fastcall GetBinary(AnsiString &key, TDataBuf* buf);
   // functions below just write data and update index in memory, but don't
   // save index, or in the case of writeindex, don't cascade to parent..
   virtual TFLoffset __fastcall PutBinary(AnsiString &key, TDataBuf *buf, bool SaveIndex=true);
   //virtual TFLoffset __fastcall PutBinary(AnsiString &key, TMemoryStream *buf, bool SaveIndex=true);
   TFLoffset __fastcall WriteIndex();
};
//---------------------------------------------------------------------------
#endif
