//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <assert.h>
#pragma hdrstop

#include "FileManxxx.h"
#include "Mixmaster.h"
#include "zlib.h"
#include "view.h"
//---------------------------------------------------------------------------
#pragma link "zlib.lib"
bool UseCompression = true;
//---------------------------------------------------------------------------
int __fastcall GetAppData(TStrings *items, AnsiString &path, AnsiString &datafile)
{
   items->Clear();
   int status = DB_OK;
   TDataBuf *buf = new TDataBuf();
   if (buf!=NULL)
   {
      if ((status=GetAppBinary(path,buf,datafile))==DB_OK)
         items->Text = s(buf->data);
      delete buf;
   }
   return status;
}
//---------------------------------------------------------------------------
int __fastcall PutAppData(AnsiString &path, TStrings *items, AnsiString &datafile)
{
   TDataBuf *buf = NULL;
   if (items)
   {
      buf = new TDataBuf();
      if (items->Count) buf->Set(items->Text.c_str(),items->Text.Length());
   }
   int status = PutAppBinary(path,buf,datafile);
   if (buf) delete buf;
   return status;
}
//---------------------------------------------------------------------------
int __fastcall PutAppBinary(AnsiString &path, TDataBuf *buf, AnsiString &datafile)
{
   String nodetext;
   int status = DB_OK;
   TFMindex *idx[16] = { 0 };
   TFileManager *fman = new TFileManager(datafile);

   idx[0] = new TFMindex(fman);
   int i=1; while ((nodetext = GetParam(i-1,path,PS.c_str())) != NULL)
   {
      if (GetParam(i,path,PS.c_str()).IsEmpty())
      {
         idx[i-1]->PutBinary(nodetext,buf);
         status = fman->LoStatus();
         break;
      }
      idx[i] = new TFMindex(fman,nodetext,idx[i-1]);
      i++;
   }

   for (i=i-1; i>0; i--)
      delete idx[i];
   delete fman;
   return status;
}
//---------------------------------------------------------------------------
int __fastcall GetAppBinary(AnsiString &path, TDataBuf *buf, AnsiString &datafile)
{
   int status=DB_OK;
   if (!FileExists(datafile)) return status;

   AnsiString nodetext;
   TFMindex *idx[16] = { 0 };
   TFileManager *fman = new TFileManager(datafile);

   idx[0] = new TFMindex(fman);
   int i=1; while ((nodetext = GetParam(i-1,path,PS.c_str())) != NULL)
   {
      if (GetParam(i,path,PS.c_str()).IsEmpty())
      {
         if (idx[i-1]->GetSize(nodetext)>0) idx[i-1]->GetBinary(nodetext,buf);
         status = fman->LoStatus();
         break;
      }
      idx[i] = new TFMindex(fman,nodetext,idx[i-1]);
      i++;
   }
   for (i=i-1; i>0; i--) delete idx[i];
   delete fman;
   return status;
}
//---------------------------------------------------------------------------
AnsiString __fastcall GetAppIni(AnsiString &key, AnsiString &defvalue, AnsiString &datafile)
{
   int status;
   AnsiString val;
   TStringList *ini = new TStringList();
   if ((status=GetAppData(ini,AppIniValues,datafile))==DB_OK)
   {
      val = ini->Values[key];
      if (val.IsEmpty()) val = defvalue;
   }
   delete ini;
   return val;
}
//---------------------------------------------------------------------------
int __fastcall PutAppIni(AnsiString &key, AnsiString &Value, AnsiString &datafile)
{
   int status;
   TStringList *ini = new TStringList();
   if ((status=GetAppData(ini,AppIniValues,datafile))==DB_OK)
   {
      ini->Values[key] = Value;
      status = PutAppData(AppIniValues,ini,datafile);
   }
   delete ini;
   return status;
}
//---------------------------------------------------------------------------
int __fastcall PutAppBinaryData(AnsiString &path, char *data, int length, AnsiString &datafile)
{
   TDataBuf *buffer = new TDataBuf(data,length);
   int status = PutAppBinary(path,buffer);
   delete buffer;
   return status;
}
//---------------------------------------------------------------------------
int __fastcall GetAppDataMainIndex(TStrings *items, AnsiString &datafile)
{
   TFileManager *fm = new TFileManager(datafile);
   TFMindex *idx = new TFMindex(fm);
   items->AddStrings(idx);
   int status = fm->LoStatus();
   delete idx;
   delete fm;
   return status;
}
//---------------------------------------------------------------------------
bool __fastcall AppBinaryExists(AnsiString &path, TDataBuf *data, AnsiString &datafile)
{
   TDataBuf *tmp = new TDataBuf();
   int status = GetAppBinary(path,tmp,datafile);
   bool exists = status==DB_OK && tmp->length;
   if (exists && data) data->Set(tmp->data,tmp->length);
   delete tmp;
   return exists;
}
//---------------------------------------------------------------------------
bool __fastcall AppDataExists(AnsiString &path, TStrings *data, AnsiString &datafile)
{
   TStringList *tmp = new TStringList();
   int status = GetAppData(tmp,path,datafile);
   bool exists = status==DB_OK && tmp->Count;
   if (exists && data) data->Text = tmp->Text;
   delete tmp;
   return exists;
}
//---------------------------------------------------------------------------
int __fastcall RenameAppIndex(AnsiString &Path, AnsiString &Newname,
   AnsiString &datafile)
{
   String nodetext;
   int pos,status = DB_OK;
   TFMindex *idx[16] = { 0 };
   TFileManager *fman = new TFileManager(datafile);
   idx[0] = new TFMindex(fman);

   int i=1;
   while ((nodetext=GetParam(i-1,Path,PS.c_str()))!=NULL)
   {
      if (GetParam(i,Path,PS.c_str()).IsEmpty())
      {
         if ((pos=idx[i-1]->IndexOf(nodetext))>=0)
         {
            TObject *obj = idx[i-1]->Objects[pos];
            idx[i-1]->Strings[pos] = Newname;
            idx[i-1]->Objects[pos] = obj;
            idx[i-1]->Save();
         }
         status = fman->LoStatus();
         break;
      }
      idx[i] = new TFMindex(fman,nodetext,idx[i-1]);
      i++;
   }

   for (i=i-1; i>0; i--) delete idx[i];
   delete fman;
   return status;
}
//---------------------------------------------------------------------------
int __fastcall RenameAppItem(AnsiString &Path, AnsiString &Newname,
   AnsiString &datafile)
{
   Path = Path.Trim(); //sm(Path);
   AnsiString nodetext;
   int pos,status=DB_OK;
   TFMindex *idx[16]={ 0 };
   TFileManager *fman = new TFileManager(datafile);
   idx[0] = new TFMindex(fman);
   int i=1; while ((nodetext=GetParam(i-1,Path,PS.c_str()))!=NULL)
   {
      if (GetParam(i,Path,PS.c_str()).IsEmpty())
      {
         pos = idx[i-1]->IndexOf(nodetext);
         if (pos>=0)
         {
            idx[i-1]->Strings[pos] = Newname;
            idx[i-1]->Save();
         }
         status = fman->LoStatus();
         break;
      }
      idx[i] = new TFMindex(fman,nodetext,idx[i-1]);
      i++;
   }

   for (i=i-1; i>0; i--) delete idx[i];
   delete fman;
   return status;
}
//---------------------------------------------------------------------------
long __fastcall GetThisFileSize(const AnsiString FileName)
{
  TSearchRec SearchRec;
  if(FindFirst(ExpandFileName(FileName),faAnyFile,SearchRec)==0) return SearchRec.Size;
  else return 0;
}
//---------------------------------------------------------------------------
// TFileManager
//----------------------------------------------------------------------------
__fastcall TFileManager::TFileManager(const AnsiString &Filename, bool Create) : TObject()
{
   filename = Filename;
   status = new TStringList();
   bool exists = FileExists(filename);
   if (!exists && !Create)
   {
      Status(DB_NODBERR);
      stream = NULL;
      return;
   }
   try
   {
      stream = new TFileStream(filename,(unsigned short)(exists?fmOpenReadWrite:fmCreate));
      delStream = true;
   }
   catch(...)
   {
      if (stream) delete stream;
      Status(DB_OPENDBEXC);
      return;
   }
   Init();
}
//----------------------------------------------------------------------------
__fastcall TFileManager::TFileManager(TStream *Stream) : TObject()
{
  delStream = false;
  stream = Stream;
  Init();
}
//---------------------------------------------------------------------------
__fastcall TFileManager::~TFileManager()
{
   delete status;
   delete freeList;
   if (delStream) delete stream;
}
//---------------------------------------------------------------------------
void __fastcall TFileManager::Init()
{
  status->Clear();
  startOfData = FLNIL;
  endOfData = strlen(FILEHEADER)+(2*OFSSIZE);
  freeList = new TFreeList();

  if(!stream->Size)  // Virgin file; must initialize it.
  {
     if (!WriteHeader() || !WriteStartAndEnd() || !WriteFreeList())
        Status(DB_INITVIRGINDBERR);
     return;
  }
  if (!ReadHeader() || !ReadStartAndEnd() || !ReadFreeList())
     Status(DB_INITEXISTDBERR);
}
//---------------------------------------------------------------------------
void __fastcall TFileManager::Status(int statnum)
{
   status->InsertObject(0,"",(TObject*)statnum);
}
//---------------------------------------------------------------------------
int __fastcall TFileManager::HiStatus()
{
   if (status->Count>0) return (int)status->Objects[0];
   return DB_OK;
}
//---------------------------------------------------------------------------
int __fastcall TFileManager::LoStatus()
{
   int c = status->Count;
   if (c>0) return (int)status->Objects[c-1];
   return DB_OK;
}
//---------------------------------------------------------------------------
bool __fastcall TFileManager::ErrCondition(AnsiString &Errmsg)
{
   if (!status->Count) return false;
   for (int i=0; i<status->Count; i++)
      Errmsg += "\n"+GetErrorMessage((int)status->Objects[i]);
   MessageBox(NULL,Errmsg.c_str(),"File Manager Error",
      MB_OK|MB_TASKMODAL);
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall TFileManager::SeekTo(TFLoffset offset)
{
   status->Clear();
   bool ok;
   try
   {
      if ((ok=stream->Seek(offset,soFromBeginning)==offset)==false)
         Status(DB_SEEKERR);
   }
   catch(...)
   {
      Status(DB_SEEKEXC);
      return false;
   }
   return ok;
}
//---------------------------------------------------------------------------
bool __fastcall TFileManager::WriteDat(void *dat, long size)
{
   status->Clear();
   bool ok;
   try
   {
      if ((ok=stream->Write(dat,size)==size)==false)
         Status(DB_WRITEERR);
   }
   catch(...)
   {
      Status(DB_WRITEEXC);
      return false;
   }
   return ok;
}
//---------------------------------------------------------------------------
bool __fastcall TFileManager::ReadDat(void *dat, long size)
{
   bool ok;
   status->Clear();
   try
   {
      if ((ok=stream->Read(dat,size)==size)==false)
         Status(DB_READERR);
   }
   catch(...)
   {
      Status(DB_READERR);
      return false;
   }
   return ok;
}
//---------------------------------------------------------------------------
bool __fastcall TFileManager::ReadOfs(const TFLoffset ofs, void *data, long size)
{
   if (!SeekTo(ofs)) return false;
   return ReadDat(data,size);
}
//---------------------------------------------------------------------------
bool __fastcall TFileManager::WriteOfs(const TFLoffset ofs, void *data, long size)
{
   if (!SeekTo(ofs)) return false;
   return WriteDat(data,size);
}
//---------------------------------------------------------------------------
bool __fastcall TFileManager::ReadHeader()
{
   status->Clear();
   int hdrlen = strlen(FILEHEADER);
   char *header = new char[hdrlen+1];
   try
   {
      if (!ReadOfs(0,header,hdrlen))
      {
         Status(DB_READHEADERR);
         delete [] header;
         return false;
      }
   }
   catch(...)
   {
      Status(DB_READHEADEXC);
      delete [] header;
      return false;
   }
   if (memcmp(header,FILEHEADER,hdrlen)!=0 &&
       memcmp(header,FILEHEADE1,hdrlen)!=0)
   {
      Status(DB_INVALIDHEADERR);
      delete [] header;
      return false;
   }

   delete [] header;
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall TFileManager::ReadStartAndEnd()
{
   status->Clear();
   try
   {
      if (!ReadOfs(strlen(FILEHEADER),&startOfData,2*OFSSIZE))
      {
         Status(DB_READSODERR);
         return false;
      }
   }
   catch(...)
   {
     Status(DB_READSODEXC);
     return false;
   }
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall TFileManager::ReadFreeList()
{
  status->Clear();
  try
  {
     if (!SeekTo(endOfData))
     {
        Status(DB_SEEKFREEERR);
        return false;
     }
     if (!freeList->LoadFromStream(stream))
     {
        Status(DB_READFREEERR);
        return false;
     }
  }
  catch(...)
  {
     Status(DB_READFREEEXC);
     return false;
  }
  return true;
}
//---------------------------------------------------------------------------
bool __fastcall TFileManager::WriteHeader()
{
   status->Clear();
   try
   {
      if (!WriteOfs(0,FILEHEADER,strlen(FILEHEADER)))
      {
         Status(DB_WRITEHEADERR);
         return false;
      }
   }
   catch(...)
   {
      Status(DB_WRITEHEADEXC);
      return false;
   }
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall TFileManager::WriteFreeList()
{
  status->Clear();
  try
  {
     if (!SeekTo(endOfData))
     {
        Status(DB_SEEKFREEERR);
        return false;
     }
     if (!freeList->SaveToStream(stream))
     {
        Status(DB_WRITEFREEERR);
        return false;
     }
  }
  catch(...)
  {
     Status(DB_WRITEFREEEXC);
     return false;
  }
  return true;
}
//---------------------------------------------------------------------------
bool __fastcall TFileManager::WriteStartAndEnd()
{
   status->Clear();
   try
   {
      if (!WriteOfs(strlen(FILEHEADER),&startOfData,2*OFSSIZE))
      {
         Status(DB_WRITESODERR);
         return false;
      }
   }
   catch(...)
   {
     Status(DB_WRITESODEXC);
     return false;
   }
   return true;
}
//---------------------------------------------------------------------------
TFLoffset __fastcall TFileManager::Allocate(TFLspace spaceRequested)
{
  status->Clear();
  TFLoffset ofs;
  if (spaceRequested<0) spaceRequested==0;
  try
  {
     TFLspace space = spaceRequested+sizeofHeader;
     if (!AllocateInFreeList(ofs,space) && !AllocateAtEnd(ofs,space))
     {
         Status(DB_ALLOCERR);
         Deallocate(ofs);
         return FLNIL;
     }
     if (startOfData==FLNIL) startOfData=ofs;
     if (!WriteStartAndEnd() || !WriteFreeList())
     {
         Status(DB_WRITEALLOCERR);
         Deallocate(ofs);
         return FLNIL;
     }
  }
  catch(...)
  {
     Status(DB_ALLOCEXC);
     return FLNIL;
  }
  return ofs;
}
//---------------------------------------------------------------------------
bool __fastcall TFileManager::AllocateInFreeList(TFLoffset &offset, TFLspace spaceRequired)
{
   status->Clear();
   offset = FLNIL;
   TFLoffset startOfAlloc;
   try
   {
      if ((startOfAlloc=freeList->Allocate(spaceRequired))==FLNIL)
      {
        Status(DB_ALLOCFREEERR);
        return false;
     }

     if (!WriteOfs(startOfAlloc,&spaceRequired,SPCSIZE) || !WriteFreeList())
     {
        Status(DB_WRITEALLOCFREEERR);
        return false;
     }
  }
  catch(...)
  {
     Status(DB_ALLOCFREEEXC);
     return false;
  }
  offset = startOfAlloc+sizeofHeader;
  return true;
}
//---------------------------------------------------------------------------
bool __fastcall TFileManager::AllocateAtEnd(TFLoffset &offset, TFLspace spaceRequired)
{
  status->Clear();
  offset = FLNIL;
  TFLoffset ofs = endOfData+sizeofHeader;
  try
  {
     // Record the space allocated in the header:
     if (!WriteOfs(endOfData,&spaceRequired,SPCSIZE))
     {
        Status(DB_WRITEALLOCENDERR);
        return false;
     }
     // Update and record new endOfData:
     endOfData += spaceRequired;
     if (!WriteStartAndEnd())
     {
        Status(DB_WRITEALLOCSODERR);
        return false;
     }
  }
  catch(...)
  {
     Status(DB_ALLOCATENDEXC);
     return false;
  }
  offset = ofs;
  return true;
}
//---------------------------------------------------------------------------
void __fastcall TFileManager::Deallocate(TFLoffset offset)
{
   status->Clear();
   // Can't deallocate first allocated block or FLNIL:
   if (offset==FLNIL || offset==start()) return;

   // Start of record, including record header:
   TFLoffset startOfRecord = offset-(TFLoffset)sizeofHeader;
   TFLspace spaceFreed;

   if (!ReadOfs(startOfRecord,&spaceFreed,SPCSIZE))
   {
      Status(DB_DEALOCREADSORERR);
      return;
   }
   if (!AddToFreeList(startOfRecord,spaceFreed))
   {
      Status(DB_DEALOCREADFREEERR);
      return;
   }
   if (!WriteFreeList())
   {
      Status(DB_DEALLOCFREEERR);
      return;
   }
}
//---------------------------------------------------------------------------
bool __fastcall TFileManager::AddToFreeList(TFLoffset offset, TFLspace space)
{
   status->Clear();
   if (!space) return true;

   // If last record is deleted, redefine endOfData.
   if (offset+(TFLoffset)space>=endOfData)
   {  // If last record removed
      endOfData = offset;
      if (!WriteStartAndEnd())
      {
         Status(DB_ADDFREEWRITEERR);
         return false;
      }
   }
   if (!freeList->EnterFreeSpace(offset, space))
   {
      Status(DB_ADDFREEENTERERR);
      return false;
   }
   return true;
}
//---------------------------------------------------------------------------
// TDataBuf
//---------------------------------------------------------------------------
__fastcall TDataBuf::TDataBuf(const char *Data, TFLspace Length)
{
   status = DB_OK;
   type[0]=type[1]=type[2]=type[3]='\0';
   data = NULL; length = orglength = 0;
   if (Data) Set(Data,Length);
}
//---------------------------------------------------------------------------
__fastcall TDataBuf::TDataBuf(const AnsiString &Data)
{
   status = DB_OK;
   sensitive = true;
   Set(Data.c_str(),Data.Length());
}
//---------------------------------------------------------------------------
__fastcall TDataBuf::~TDataBuf()
{
   if (data) Clear();
}
//---------------------------------------------------------------------------
void __fastcall TDataBuf::Clear()
{
   status = DB_OK;
   type[0]=type[1]=type[2]=type[3]='\0';
   if (data)
   {
      if (sensitive) memset(data,'\0',length);
      delete [] data;
      data = NULL;
   }
   orglength = 0;
   length = 0;
}
//---------------------------------------------------------------------------
void __fastcall TDataBuf::Set(const char *Data, TFLspace Length)
// 'Set' completely reinitializes data structure
// 'SetData' below just set data and length
{
   Clear(); SetData(Data,Length);
   orglength = Length;
   sensitive = true;
}
//---------------------------------------------------------------------------
void __fastcall TDataBuf::SetData(const char *Data, TFLspace Length)
// see notes on 'Set', above. This does not change type[0], orglenth, sensitive
{
   status = DB_OK;
   sensitive = true;
   if (data && length>=0)
   {
      if (sensitive) memset(data,'\0',length);
      delete [] data;
   }
   data = new char[Length+1];
   if (!data)
   {
      status = DB_ALLOCERR;
      orglength = 0;
      length = 0;
      return;
   }
   if (Data) memcpy(data,Data,Length); else memset(data,'\0',Length);
   data[Length] = '\0';
   length = Length;
}
//---------------------------------------------------------------------------
bool __fastcall TDataBuf::Encrypted()
{
   return type[3]==ENCRYPTED;
}
//---------------------------------------------------------------------------
int __fastcall TDataBuf::Encrypt(const AnsiString &password)
{
   status = DB_OK;
   int result;
   if (type[3]!=CLEARTEXT) return 0;
   try
   {
      result=data_encrypt(&data,length,password.c_str(),password.Length());
      if (result==0) type[3] = ENCRYPTED;
   }
   catch(...)
   {
      status = FB_ENCRYPTERR;
      type[3] = CLEARTEXT;
   }
   return result;
}
//---------------------------------------------------------------------------
int __fastcall TDataBuf::Decrypt(const AnsiString &password)
{
   status = DB_OK;
   int result;
   if (type[3]!=ENCRYPTED) return 0;
   try
   {
      result=data_decrypt(&data,length,password.c_str(),password.Length());
      if (result==0) type[3] = CLEARTEXT;
   }
   catch(...)
   {
      status = FB_DECRYPTERR;
      type[3] = ENCRYPTED;
   }
   return result;
}
//---------------------------------------------------------------------------
bool __fastcall TDataBuf::LoadFromFile(const AnsiString &Filename)
{
   status = DB_OK;
   if (!FileExists(Filename))
   {
      status = FB_NOFILEERR;
      return false;
   }
   unsigned Length=GetThisFileSize(Filename);
   if (!Length)
   {
      Set(NULL,0);
      return true;
   }
   Clear();
   try
   {
      data = new char[Length+1];
   }
   catch(...)
   {
      status = FB_ALLOCBUFEXC;
      Set(NULL,0);
      return false;
   }
   if (!data)
   {
      status = FB_ALLOCBUFERR;
      Set(NULL,0);
      return false;
   }
   try
   {
      TFileStream *f;
      try
      {
         f = new TFileStream(Filename,fmOpenRead);
         f->ReadBuffer(data,Length); data[Length] = '\0';
      }
      catch(...)
      {
         status = FB_OPENREADFILEEXC;
         Set(NULL,0);
         return false;
      }
      orglength = Length;
      length = Length;
      delete f;
   }
   catch (...)
   {
      status = FB_READFILEEXC;
      Set(NULL,0);
      return false;
   }
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall TDataBuf::SaveToFile(const AnsiString &Filename)
{
   status = FB_OK;
   TFileStream *f;
   try
   {
      try
      {
         f = new TFileStream(Filename,fmCreate);
      }
      catch(...)
      {
         status = FB_OPENWRITEFILEEXC;
         return false;
      }
      f->WriteBuffer(data,length);
      delete f; f = NULL;
   }
   catch(...)
   {
      status = FB_WRITEFILEEXC;
      if (f) delete f;
      return false;
   }
   return true;
}
//---------------------------------------------------------------------------
/*AnsiString __fastcall ZipErrMsg(const int errcode)
{
   AnsiString msg;
   switch (errcode)
   {
      case Z_STREAM_ERROR  : msg = "Decompression Error: Z_STREAM_ERROR"; break;
      case Z_MEM_ERROR     : msg = "Decompression Error: Z_MEM_ERROR"; break;
      case Z_BUF_ERROR     : msg = "Decompression Error: Z_BUF_ERROR"; break;
      case Z_VERSION_ERROR : msg = "Decompression Error: Z_VERSION_ERROR"; break;
      default:
         msg = "Decompression Error: "+AnsiString(errcode);
   }
   return msg;
}*/
//---------------------------------------------------------------------------
bool __fastcall TDataBuf::Compressed()
{
   return type[3]==COMPRESSED;
}
//---------------------------------------------------------------------------
int __fastcall TDataBuf::Compress()
{
   status = FB_OK;
   z_stream s;
   int err=0;

   s.zalloc = (alloc_func) 0;
   s.zfree = (free_func) 0;
   s.opaque = (voidpf) 0;
   s.next_in = NULL;

   try
   {
      if ((err=deflateInit2(&s,Z_DEFAULT_COMPRESSION,Z_DEFLATED,15,9,Z_DEFAULT_STRATEGY))==Z_OK)
      {
         int len = length*1.2+16;
         byte *outdata = new byte[len];

         orglength = length;  // should BE length (not 0) but it sometimes isn't...
         s.avail_in = length;
         s.next_in = (byte*)data;
         s.next_out = outdata;
         s.avail_out = len;
         if ((err=deflate(&s, Z_FINISH))==Z_STREAM_END)
         {
            if ((err=deflateEnd(&s))==Z_OK)
            {
               SetData((char*)outdata,s.total_out);
               type[3]=COMPRESSED;
            }
         }
         delete [] outdata;
      }
      if (err)
      {
         status = FB_ZIPINFLERR;
      }
   }
   catch(...)
   {
      status = FB_ZIPINFLEXC;
      if (!err) return Z_STREAM_ERROR;
      return err;
   }
   return err;
}
//---------------------------------------------------------------------------
int __fastcall TDataBuf::Decompress()
{
   status = DB_OK;
   z_stream s;
   int err=0;

   s.zalloc = (alloc_func) 0;
   s.zfree = (free_func) 0;
   s.opaque = (voidpf) 0;

   s.next_in = (byte*)data;
   s.avail_in = length;
   s.next_out = NULL;

   try
   {
      if ((err=inflateInit2(&s,15))==Z_OK)
      {
         int len = orglength;
         byte *outdata = new byte[len];
         s.avail_out = len;
         s.next_out = outdata;
         if ((err=inflate(&s, Z_FINISH))==Z_STREAM_END)
         {
            if ((err=inflateEnd(&s))==Z_OK)
            {
               SetData((char*)outdata,s.total_out);
               type[3]=CLEARTEXT;
            }
         }
         delete [] outdata;
      }
      if (err)
      {
         status = FB_ZIPDEFLERR;
      }
   }
   catch(...)
   {
      if (!err) return Z_STREAM_ERROR;
      status = FB_ZIPDEFLEXC;
      return err;
   }
   return err;
}
//---------------------------------------------------------------------------
bool __fastcall TDataBuf::IsEmpty()
{
   return length==0;
}
//---------------------------------------------------------------------------
bool __fastcall TDataBuf::IsIndex()
{
   return type[1]==ISINDEX;
}
//---------------------------------------------------------------------------
bool __fastcall TDataBuf::IsData()
{
   return type[1]==ISDATA;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TDataBuf::str()
{
   return data ? AnsiString(data) : AnsiString("");
}
//---------------------------------------------------------------------------
char* __fastcall TDataBuf::c_str()
{
   char *doto = "\0";
   return data ? data : doto;
}
//---------------------------------------------------------------------------
// TFreeList
//---------------------------------------------------------------------------
__fastcall TFreeList::TFreeList() : TObject()
{
   status = FL_OK;
   offset = new TList();
   space = new TList();
   lastOffset = 0;
   lastSpace = 0;
}
//---------------------------------------------------------------------------
__fastcall TFreeList::~TFreeList()
{
   delete offset;
   delete space;
}
//---------------------------------------------------------------------------
bool __fastcall TFreeList::AddFreeSpace(TFLoffset Offset, TFLspace Space)
{
   int i;
   for (i = 0; i < offset->Count; i++)
      if (Offset < getOffset(i))
         break;

   offset->Insert(i,(void*)Offset); lastOffset = Offset;
   space->Insert(i,(void*)Space);  lastSpace = Space;

   return true;
}
//---------------------------------------------------------------------------
TFLoffset __fastcall TFreeList::Allocate(TFLspace Space)
{
   int i;
   for (i = 0; i < offset->Count; i++)
   {
      if (Space <= getSpace(i))
      {
         TFLoffset ofs = getOffset(i);
         space->Items[i] = (void*)(getSpace(i)-Space);
         if (space->Items[i] == 0)
         {
            offset->Delete(i);
            space->Delete(i);
         }
         else
            offset->Items[i] = (void*)(getOffset(i)+Space);
         return ofs;
      }
   }
   return FLNIL;
}
//---------------------------------------------------------------------------
void __fastcall TFreeList::AttemptMerge(int i)
{
   if (i < offset->Count-1)
   {
      if (getOffset(i)+(TFLoffset)getSpace(i) == getOffset(i+1))
      {
         space->Items[i] = (void*)(getSpace(i)+getSpace(i+1));
         offset->Delete(i+1);
         space->Delete(i+1);
      }
   }
}
//---------------------------------------------------------------------------
bool __fastcall TFreeList::Coalesce(TFLoffset Offset, TFLspace Space)
{
   int i;
   for (i = 0; i < offset->Count; i++)
   {
      // try merging to right of existing space...
      if (Offset == getOffset(i)+(TFLoffset)getSpace(i))
      {
         space->Items[i] = (void*)(getSpace(i)+Space);
         AttemptMerge(i);
         return true;
      }
      // try merging to left...
      if (Offset+Space == getOffset(i))
      {
         offset->Items[i] = (void*)Offset; lastOffset = Offset;
         space->Items[i] = (void*)(getSpace(i)+Space); lastSpace = getSpace(i);
         return true;
      }
   }
   return false;
}
//---------------------------------------------------------------------------
bool __fastcall TFreeList::EnterFreeSpace(TFLoffset Offset, TFLspace Space)
{
   if (Coalesce(Offset,Space)) return true;
   return AddFreeSpace(Offset,Space);
}
//---------------------------------------------------------------------------
bool __fastcall TFreeList::LoadFromStream(TStream *f)
{
  status = FL_OK;
  TFLspace spc; TFLoffset ofs;
  int i,count,spsize=SPCSIZE,ofsize=OFSSIZE,insize=sizeof(int);
  try
  {
     if (f->Read(&count,insize)!=insize)
     {
        status = FL_READERR;
        return false;
     }
     if (offset->Count) offset->Clear();
     i=-1; while(++i<count)
     {
        if (f->Read(&ofs,ofsize)!=ofsize)
        {
           status = FL_READERR;
           return false;
        }
        offset->Add((void*)ofs);
     }
     if (space->Count) space->Clear();
     i=-1; while (++i<count)
     {
        if (f->Read(&spc,spsize)!=spsize)
        {
           status = FL_READERR;
           return false;
        }
        space->Add((void*)spc);
     }
  }
  catch(...)
  {
     status = FL_READEXC;
     return false;
  }
  return true;
}
//---------------------------------------------------------------------------
bool __fastcall TFreeList::SaveToStream(TStream *f)
{
   TFLspace spc; TFLoffset ofs;
   int i,count=offset->Count,ofsize=OFSSIZE,spsize=SPCSIZE,insize=sizeof(int);
   try
   {
      if (f->Write(&count,insize)!=insize)
      {
         status = FL_WRITEERR;
         return false;
      }
      i=-1; while (++i<count)
      {
         ofs = getOffset(i);
         if (f->Write(&ofs,ofsize)!=ofsize)
         {
            status = FL_WRITEERR;
            return false;
         }
      }
      i=-1; while (++i<count)
      {
         spc = getSpace(i);
         if (f->Write(&spc,spsize)!=spsize)
         {
            status = FL_WRITEERR;
            return false;
         }
      }
   }
   catch(...)
   {
      status = FL_WRITEEXC;
      return false;
   }
   return true;
}
//---------------------------------------------------------------------------
int __fastcall TFreeList::Count()
{
   return offset->Count;
}
//---------------------------------------------------------------------------
// TFMindex
//---------------------------------------------------------------------------
__fastcall TFMindex::TFMindex(TFileManager *Fm, AnsiString Name, TFMindex *Parent)
{
   fm = Fm;
   name = Name;
   parent = Parent;
   if (parent && !name.IsEmpty())
      offset = parent->GetOffset(name);
   else
   {
      if (fm->start() == FLNIL) // initialize first allocation if necessary
      {
         offset = FLNIL;
         if (!fm->WriteOfs(fm->Allocate(OFSSIZE),&offset,OFSSIZE))
         {
            fm->Status(DB_INITINDEXERR);
            return;
         }
      }
      else // or just read offset
      {
         if (!fm->ReadOfs(fm->start(),&offset,OFSSIZE))
         {
            offset = FLNIL;
            fm->Status(DB_INITINDEXERR);
            return;
         }
      }
   }
   if (offset==FLNIL) return;

   void *p;
   TDataBuf *buf = new TDataBuf();
   if (!buf || buf->status!=FB_OK)
   {
      fm->Status(DB_BADBUFERR);
      fm->Status(DB_WRITEINDEXERR);
      return;
   }
   if (buf)
   {
      if (!fm->SeekTo(offset) ||
        !fm->ReadDat(&buf->type[0],TYPSIZE) ||
        !fm->ReadDat(&buf->length,SPCSIZE) ||
        !fm->ReadDat(&buf->orglength,SPCSIZE))
      {
         fm->Status(DB_OPENINDEXERR);
         delete buf;
         return;
      }

      try
      {
         if (buf->data) delete [] buf->data;
         buf->data = new char[buf->length]; // allocation here
      }
      catch(...)
      {
         fm->Status(DB_ALLOCINDEXEXC);
      }

      if (!fm->ReadDat(buf->data,buf->length))
      {
         fm->Status(DB_OPENINDEXERR);
         delete buf;
         return;
      }

      if (buf->Compressed() && buf->Decompress()!=FB_OK)
      {
         fm->Status(DB_ZIPDEFLERR);
         fm->Status(DB_OPENINDEXERR);
         delete buf;
         return;
      }
      Text = AnsiString(buf->data);
      int i=-1; while(++i<Count)
      {
         if (!fm->ReadDat(&p,PTRSIZE))
         {
            fm->Status(DB_OPENINDEXERR);
            delete buf;
            return;
         }
         Objects[i] = (TObject*)p;
      }
      delete buf;
   }
}
//---------------------------------------------------------------------------
void __fastcall TFMindex::ShowIndex()
{
   String idx;
   for (int i=0; i<Count; i++)
      idx += Strings[i]+"     "+String((int)Objects[i])+"\n";
   ShowMessage(idx);
}
//---------------------------------------------------------------------------
TFLspace __fastcall TFMindex::GetSize(AnsiString &key)
{
   TFLoffset ofs = GetOffset(key);
   if (ofs == FLNIL) return 0;

   TFLspace spc=0;
   char type[TYPSIZE];
   if (!fm->ReadOfs(ofs,&type[0],TYPSIZE) ||
       !fm->ReadDat(&spc,SPCSIZE))
   {
      fm->Status(DB_GETDATSIZEERR);
      return 0;
   }
   return spc;
}
//---------------------------------------------------------------------------
char __fastcall TFMindex::GetType(AnsiString &key)
{
   TFLoffset ofs=GetOffset(key);
   if (ofs==FLNIL) return -1;

   char type[TYPSIZE];
   if (!fm->ReadOfs(ofs,&type[0],TYPSIZE))
   {
      fm->Status(DB_GETDATTYPEERR);
      return -1;
   }
   return type[0];
}
//---------------------------------------------------------------------------
TFLoffset __fastcall TFMindex::GetOffset(AnsiString &key)
{
   int p = IndexOf(key);
   return p<0 ? FLNIL : (TFLoffset)Objects[p];
}
//---------------------------------------------------------------------------
TFLoffset __fastcall TFMindex::SetOffset(AnsiString &key, TFLoffset Offset)
{
   if (key.IsEmpty()) return FLNIL;
   int p = IndexOf(key);
   if (p < 0)
   {
      Add(key);
      p = Count-1;
   }
   Objects[p] = (TObject*)Offset;
   return Offset;
}
//---------------------------------------------------------------------------
TFLoffset __fastcall TFMindex::PutOffset(AnsiString &key, TFLoffset Offset)
{
   TFLoffset ofs = SetOffset(key,Offset); Save();
   return ofs;
}
//---------------------------------------------------------------------------
TFLoffset __fastcall TFMindex::WriteIndex()
{
   if (offset!=FLNIL) // deallocate previous offset to index
      fm->Deallocate(offset);

   TDataBuf *buf = new TDataBuf(Text.c_str(),Text.Length()+1);
   if (buf && buf->status!=FB_OK)
   {
      fm->Status(DB_BADBUFERR);
      fm->Status(DB_WRITEINDEXERR);
      delete buf;
      return FLNIL;
   }
   if (buf && buf->status==FB_OK)
   {
      buf->type[0] = ISINDEX;
      buf->type[1] = 0;
      buf->type[2] = 0;
      buf->type[3] = 0;
      if (UseCompression && buf->Compress()!=FB_OK)
      {
         fm->Status(DB_ZIPDEFLERR);
         fm->Status(DB_WRITEINDEXERR);
         delete buf;
         return FLNIL;
      }
      offset = fm->Allocate(TYPSIZE+(SPCSIZE*2)+buf->length+(Count*PTRSIZE));
      if (!fm->SeekTo(offset) ||
          !fm->WriteDat(&buf->type[0],TYPSIZE) ||
          !fm->WriteDat(&buf->length,SPCSIZE) ||
          !fm->WriteDat(&buf->orglength,SPCSIZE) ||
          !fm->WriteDat(buf->data,buf->length))
      {
         fm->Status(DB_WRITEINDEXERR);
         delete buf;
         return FLNIL;
      }
      int i=-1; while(++i<Count)
      {
         void *p = Objects[i];
         if (!fm->WriteDat(&p,PTRSIZE))
         {
            fm->Status(DB_WRITEINDEXERR);
            delete buf;
            return FLNIL;
         }
      }
      delete buf;
   }
   return offset;
}
//---------------------------------------------------------------------------
TFLoffset __fastcall TFMindex::Save()
{
   TFLoffset ofs = WriteIndex();
   if (ofs==FLNIL) return ofs;

   if (parent) parent->PutOffset(name,offset);
   else
   {
      if (!fm->WriteOfs(fm->start(),&offset,OFSSIZE))
      {
         fm->Status(DB_WRITEINDEXOFSERR);
         return FLNIL;
      }
   }
   return ofs;
}
//---------------------------------------------------------------------------
char* __fastcall TFMindex::GetBinary(AnsiString &key, TDataBuf *buf)
{
   if (!buf) return NULL;

   TFLoffset ofs = GetOffset(key);
   if (ofs==FLNIL) return NULL;

   if (!fm->SeekTo(ofs) ||
      !fm->ReadDat(&buf->type[0],TYPSIZE) ||
      !fm->ReadDat(&buf->length,SPCSIZE)  ||
      !fm->ReadDat(&buf->orglength,SPCSIZE))
   {
      fm->Status(DB_GETBINARYERR);
      buf->Clear();
      return NULL;
   }
   try
   {
      if (buf->data) delete[] buf->data;
      buf->data = new char[buf->length+1];
      buf->data[buf->length]=0;
   }
   catch(...)
   {
      fm->Status(DB_GETBINALLOCEXC);
      buf->Clear();
      return NULL;
   }
   if (!fm->ReadDat(buf->data,buf->length))
   {
      fm->Status(DB_GETBINARYERR);
      buf->Clear();
      return NULL;
   }
   if (buf->Compressed() && buf->Decompress()!=FB_OK)
   {
      fm->Status(DB_ZIPINFLERR);
      fm->Status(DB_GETBINARYERR);
      buf->Clear();
      return NULL;
   }
   return buf->data;
}
//---------------------------------------------------------------------------
/*TFLoffset __fastcall TFMindex::PutBinary(AnsiString &key, TMemoryStream* buf, bool SaveIndex)
{
   // get key id or add if not already there
   int pos = IndexOf(key);
   if (pos < 0)
   {
      AddObject(key,(TObject*)FLNIL);
      pos = Count-1;
   }
   // get offset...deallocate, allocate...write space then data
   TFLoffset ofs = GetOffset(key);
   if (ofs != FLNIL)
      fm->Deallocate(ofs);

   if (!buf)
      Delete(IndexOf(key));
   else
   {
      void *p;
      char type[4] = { ISDATA,0,0,0 };
      int orglength = buf->Size;
      if (UseCompression) buf->Compress();
      if ((ofs = fm->Allocate(TYPSIZE+(SPCSIZE*2)+buf->Size+(Count*PTRSIZE))) != FLNIL)
      {
         long length = buf->Size;
         fm->SeekTo(ofs);
         fm->WriteDat(&type[0],TYPSIZE);
         fm->WriteDat(&length,SPCSIZE);
         fm->WriteDat(&orglength,SPCSIZE);
         fm->WriteDat(buf->Memory,buf->Size);
         // added to make index and data saves sameo sameo
         for (int i=0; i<Count; i++)
         {
            p = Objects[i];
            fm->WriteDat(&p,PTRSIZE);
         }
      }
      // assign new offset to index key and save
      Objects[pos] = (TObject*)ofs;
   }
   if (SaveIndex) Save();
   return ofs;
}*/
//---------------------------------------------------------------------------
TFLoffset __fastcall TFMindex::PutBinary(AnsiString &key, TDataBuf* buf, bool SaveIndex)
{
   // get key id or add if not already there
   int pos = IndexOf(key);
   if (pos < 0)
   {
      AddObject(key,(TObject*)FLNIL);
      pos = Count-1;
   }
   // get offset...deallocate, allocate...write space then data
   TFLoffset ofs = GetOffset(key);
   if (ofs!=FLNIL) fm->Deallocate(ofs);

   if (!buf) Delete(IndexOf(key));
   else
   {
      void *p;
      buf->type[0] = ISDATA;
      buf->type[1] = 0;
      buf->type[2] = 0;
      buf->type[3] = 0;
      if (UseCompression && buf->Compress()!=FB_OK)
      {
         fm->Status(DB_ZIPDEFLERR);
         fm->Status(DB_GETBINARYERR);
         buf->Clear();
         return NULL;
      }
      if ((ofs=fm->Allocate(TYPSIZE+(SPCSIZE*2)+buf->length+(Count*PTRSIZE)))!=FLNIL)
      {
         if (!fm->SeekTo(ofs) ||
            !fm->WriteDat(&buf->type[0],TYPSIZE) ||
            !fm->WriteDat(&buf->length,SPCSIZE) ||
            !fm->WriteDat(&buf->orglength,SPCSIZE) ||
            !fm->WriteDat(buf->data,buf->length))
         {
            fm->Status(DB_PUTBINARYERR);
            return NULL;
         }
         // added to make index and data saves sameo sameo
         int i=-1; while(++i<Count)
         {
            p = Objects[i];
            if (!fm->WriteDat(&p,PTRSIZE))
            {
               fm->Status(DB_PUTBINARYERR);
               return NULL;
            }
         }
      }
      // assign new offset to index key and save
      Objects[pos] = (TObject*)ofs;
   }
   if (SaveIndex) Save();
   return ofs;
}
//---------------------------------------------------------------------------
/*int __fastcall PutAppBinary(AnsiString &path, TMemoryStream *buf, AnsiString &datafile)
{
   String nodetext;
   int status = DB_OK;
   TFMindex *idx[16] = { 0 };
   TFileManager *fman = new TFileManager(datafile);
   idx[0] = new TFMindex(fman);

   int i=1; while ((nodetext = GetParam(i-1,path,PS.c_str())) != NULL)
   {
      if (GetParam(i,path,PS.c_str()).IsEmpty())
      {
         idx[i-1]->PutBinary(nodetext,buf);
         status = fman->status;
         break;
      }
      idx[i] = new TFMindex(fman,nodetext,idx[i-1]);
      i++;
   }

   for (i=i-1; i>0; i--)
      delete idx[i];
   delete fman;
   return status;
}*/
AnsiString __fastcall TFileManager::GetErrorMessage(int ErrNo)
{
   switch (ErrNo)
   {
      case DB_OK: "All is well!"; break;

      case DB_OPENDBEXC: return "Error opening database";
      case DB_INITVIRGINDBERR: return "Error creating database";
      case DB_INITEXISTDBERR: return "Error initializing database";
      case DB_INVALIDHEADERR: return "Invalid database header";

      case DB_NODBERR: return "File not found";
      case DB_SEEKERR:
      case DB_SEEKEXC: return "Data seek error";
      case DB_READERR:
      case DB_READEXC: return "Data read error";
      case DB_WRITEERR:
      case DB_WRITEEXC: return "Data write error";

      case DB_READHEADERR:
      case DB_READHEADEXC:
      case DB_WRITEHEADERR:
      case DB_WRITEHEADEXC: return "Database header error";

      case DB_READSODERR:
      case DB_READSODEXC:
      case DB_WRITESODERR:
      case DB_WRITESODEXC: return "Database start-of-data error";

      case DB_READFREEERR:
      case DB_READFREEEXC:
      case DB_WRITEFREEERR:
      case DB_WRITEFREEEXC:
      case DB_WRITEALLOCENDERR:
      case DB_WRITEALLOCSODERR:
      case DB_ALLOCFREEERR:
      case DB_ALLOCFREEEXC:
      case DB_ADDFREEWRITEERR:
      case DB_ADDFREEENTERERR:
      case DB_WRITEALLOCFREEERR: return "Freelist allocation error";
      case DB_DEALOCREADFREEERR:
      case DB_DEALLOCFREEERR: return "Freelist deallocation error";

      case DB_WRITEALLOCERR:
      case DB_ALLOCERR:
      case DB_ALLOCEXC:
      case DB_ALLOCATENDEXC: return "Data allocation error";
      case DB_DEALOCREADSORERR: return "Data de-allocation error";

      case DB_GETBINARYERR:
      case DB_GETBINALLOCEXC: return "Error loading program data from disk";
      case DB_PUTBINARYERR: return "Error saving program data to disk";

      case DB_OPENINDEXERR:
      case DB_OPENINDEXEXC:
      case DB_ALLOCINDEXEXC: return "Error opening database index";

      case DB_WRITEINDEXERR:
      case DB_WRITEINDEXOFSERR: return "Error storing database index";
      case DB_INITINDEXERR: "Error initializing database index";

      case DB_GETDATSIZEERR: return "Error getting data size";
      case DB_GETDATTYPEERR: return "Error getting data type";
      case DB_BADBUFERR: return "Initialization of data buffer failed";

      case DB_ZIPDEFLERR:
      case DB_ZIPINFLERR: return "Error processing program data";
      default: return "Unknown file manager error!";
   }
   return "";
}
//---------------------------------------------------------------------------




