//---------------------------------------------------------------------------
#ifndef OptionsDlgsH
#define OptionsDlgsH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ComCtrls.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\Dialogs.hpp>
#include <vcl\Buttons.hpp>
//---------------------------------------------------------------------------
bool __fastcall GetPreferences(AnsiString &PageCap=AnsiString(""));

class TOptionsDlg : public TForm
{
__published:	// IDE-managed Components
  TButton *OkBtn;
  TButton *CancelBtn;
  TColorDialog *ColorDialog1;
  TPageControl *PageControl1;
  TTabSheet *TabSheet3;
  TGroupBox *GroupBox6;
  TLabel *Label1;
  TEdit *QuoteMarkEdit;
	TTabSheet *EdSheet;
  TGroupBox *EdWrapGroup;
  TRadioButton *EdWrapNotBtn;
  TRadioButton *EdWrapWinBtn;
  TTabSheet *TabSheet2;
  TGroupBox *SendWrapGroup;
  TLabel *Label2;
  TRadioButton *SendWrapNotBtn;
  TRadioButton *SendWrapWinBtn;
  TRadioButton *SendWrapCharBtn;
  TEdit *SendWrapCharEdit;
  TCheckBox *DontWrapQuotes;
  TTabSheet *PgpSheet;
  TGroupBox *GroupBox1;
  TEdit *PgpPublicKeyring;
  TButton *BrowsePubring;
  TOpenDialog *OpenPubring;
  TOpenDialog *OpenSecring;
  TButton *HelpBtn;
  TOpenDialog *OpenImport;
  TEdit *SendChainLogMax;
  TLabel *Label8;
  TEdit *SendSMTPLogMax;
  TLabel *Label9;
	TTabSheet *RecSheet;
  TTabSheet *TabSheet5;
  TEdit *RemailerTimeOut;
  TLabel *Label10;
  TEdit *ReceivePOP3LogMax;
  TLabel *Label11;
  TEdit *RemailerErrChkLogMax;
  TLabel *Label12;
  TLabel *Label3;
  TLabel *Label14;
  TLabel *Label7;
  TButton *ImportBtn;
  TCheckBox *AutoImportBox;
  TBevel *Bevel1;
  TLabel *PublicKeyring6;
  TLabel *SecretKeyring6;
  TBevel *Bevel2;
  TLabel *Label13;
  TGroupBox *GroupBox5;
  TLabel *Label5;
  TLabel *Label4;
  TEdit *StatsMinutes;
  TCheckBox *EnableCpkBox;
  TCheckBox *SendDateHdrBox;
  TLabel *Label15;
  TEdit *KeepPassMins;
  TUpDown *UpDown1;
  TLabel *Label16;
	TTabSheet *NymSheet;
	TCheckBox *NymShowPopupBox;
	TLabel *Label17;
	TMemo *NymCmdsEditor;
	TLabel *Label18;
	TCheckBox *NymAutoDecryptBox;
	TCheckBox *SortMailboxes;
	TCheckBox *ShowBetaTest;
	TTabSheet *TabSheet1;
	TLabel *Label19;
	TEdit *UpdateWizTimeOut;
	TLabel *Label20;
	TUpDown *UpDown2;
	TUpDown *UpDown3;
	TUpDown *UpDown4;
	TUpDown *UpDown5;
	TUpDown *UpDown6;
	TUpDown *UpDown7;
	TUpDown *UpDown8;
	TUpDown *UpDown9;
	TGroupBox *GroupBox2;
	TLabel *Label21;
	TMemo *ReadMailHdrs;
	TCheckBox *CompactPgpSig;
	TLabel *Label22;
	TLabel *Label23;
	TMemo *NymServersEditor;
	TGroupBox *GroupBox4;
	TLabel *Label24;
	TEdit *DBcopies;
	TLabel *Label25;
	TUpDown *UpDown10;
	TGroupBox *GroupBox7;
	TLabel *Label6;
	TPanel *ColorBox;
	TButton *ColorBtn;
	TButton *ApplyColorBtn;
	TButton *BrowseSecring;
	TEdit *PgpSecretKeyring;
	TLabel *Label26;
	TLabel *Label27;
	TCheckBox *UsePgpKeys;
	TCheckBox *AutoVerifyClear;
	TCheckBox *SaveClearBox;
	TButton *ClearCacheBtn;
  void __fastcall SendWrapBtnClick(TObject *Sender);
  void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
  void __fastcall SendWrapCharEditExit(TObject *Sender);
  void __fastcall StatsMinutesExit(TObject *Sender);
  void __fastcall ColorBtnClick(TObject *Sender);
  void __fastcall ApplyColorBtnClick(TObject *Sender);
  void __fastcall PageControl1Change(TObject *Sender);
  void __fastcall BrowsePubringClick(TObject *Sender);
  void __fastcall BrowseSecringClick(TObject *Sender);
  void __fastcall HelpBtnClick(TObject *Sender);
  void __fastcall ResetBtnClick(TObject *Sender);
  void __fastcall ImportBtnClick(TObject *Sender);
  void __fastcall EnableCpkBoxClick(TObject *Sender);
	void __fastcall UsePgpKeysClick(TObject *Sender);
	void __fastcall ClearCacheBtnClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
  AnsiString cap;
  TStringList *ini;
  bool cpunkchange,initcomplete;// both used by cyberpunk enable
  AnsiString seckeyfile,pubkeyfile,impkeyfile;
  __fastcall TOptionsDlg(TComponent* Owner);
  bool __fastcall CheckPGPFilenameColision();
  void __fastcall SaveIni();
};

const AnsiString PgpBegPubKeyBlk = "-----BEGIN PGP PUBLIC KEY BLOCK-----";
const AnsiString PgpEndPubKeyBlk = "-----END PGP PUBLIC KEY BLOCK-----";
const AnsiString PgpBegSecKeyBlk = "-----BEGIN PGP SECRET KEY BLOCK-----";
const AnsiString PgpEndSecKeyBlk = "-----END PGP SECRET KEY BLOCK-----";

//---------------------------------------------------------------------------
extern TOptionsDlg *OptionsDlg;
//---------------------------------------------------------------------------
#endif
