//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <vcl\registry.hpp>
#include <assert.h>
#include <math.h>
#pragma hdrstop

#include "PgpPassEx.h"
#include "fileman.h"
#include "pgp.h"
#include "global.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TPgpPassForm *PgpPassForm;
#define s(m) AnsiString(m)
//---------------------------------------------------------------------------
bool __fastcall PGPGETSecureModePassphrase(TForm *Owner, bool &CancelMode,
   AnsiString &Phrase)
{
   Phrase = "";
   AnsiString s;
   bool success = false;
   TPgpPassForm *pf = new TPgpPassForm(mSecureModePhrase,NULL);
   if (!CancelMode) pf->ClearModeBtn->Visible = false;
   pf->ShowModal();
   switch (pf->ModalResult)
   {
      case mrOk:
         Phrase = pf->Phrase->Text;
         CancelMode = false;
         success = true;
         break;
      case mrCancel:
         CancelMode = false;
         success = false;
         break;
      case mrAbort:
         CancelMode = true;
         success = false;
         break;
   }
   delete pf;
   return success;
}
//---------------------------------------------------------------------------
bool __fastcall PGPGETDecryptionPassphrase(TForm *Owner, AnsiString &Phrase)
{
   Phrase="";
   AnsiString s;
   bool success=false;
   TPgpPassForm *pf = new TPgpPassForm(mDecryptionPhrase,Owner);
   if (!Owner) pf->SaveClearBox->Visible = false; // secure mode--mainform not open
   pf->ShowModal();
   if (pf->ModalResult==mrOk)
   {
      Phrase = pf->Phrase->Text;
      success = true;
   }
   delete pf;
   return success;
}
//---------------------------------------------------------------------------
bool __fastcall PGPGETConventionalPassphrase(TForm *Owner, AnsiString &Phrase)
{
   Phrase = "";
   AnsiString s;
   bool success = false;
   TPgpPassForm *pf = new TPgpPassForm(mConventionalPhrase,Owner);
   pf->ShowModal();
   if (pf->ModalResult==mrOk)
   {
      Phrase = pf->Phrase->Text;
      success = true;
   }
   delete pf;
   return success;
}
//---------------------------------------------------------------------------
bool __fastcall PGPGETSignKeyIDAndPassphrase(TForm *Owner, TStrings *Keys,
   int &CurrentKey, AnsiString &Phrase)
{
   Phrase = "";
   AnsiString s;
   bool success = false;
   TPgpPassForm *pf = new TPgpPassForm(mSignKeyPhrase,Owner);
   pf->Keyid->Items->Text = Keys->Text;
   if (CurrentKey>=0 && CurrentKey<Keys->Count)
      pf->Keyid->ItemIndex = CurrentKey;

   pf->ShowModal();
   if (pf->ModalResult==mrOk)
   {
      if (pf->Keyid->ItemIndex>=0)
      {
         CurrentKey = pf->Keyid->ItemIndex;
         Phrase = pf->Phrase->Text;
         success = true;
      }
   }
   delete pf;
   return success;
}
//---------------------------------------------------------------------------
bool __fastcall PGPGETSecretKeyPassphrase(TForm *Owner, AnsiString &UserId,
   AnsiString &Phrase)
{
   AnsiString s;
   bool success = false;
   TPgpPassForm *pf = new TPgpPassForm(mSecretKeyPhrase,Owner);
   TListBox *skl = pf->SecretKeyList;
   skl->Items->Text = UserId;
   skl->Sorted = false;
   bool ok=false; for (int i=0; i<skl->Items->Count; i++)
      if (skl->Items->Strings[i].Pos("0x")!=1) ok = true;
   if (ok) while(skl->Items->Strings[0].Pos("0x")==1)
   {
      skl->Items->Add(skl->Items->Strings[0]);
      skl->Items->Delete(0);
   }
   pf->Phrase->Text = Phrase; Phrase = "";
   pf->Phrase->SelStart = pf->Phrase->Text.Length();
   pf->ShowModal();
   if (pf->ModalResult==mrOk)
   {
      Phrase = pf->Phrase->Text;
      success = true;
   }
   delete pf;
   return success;
}
//---------------------------------------------------------------------------
#define NUMRANGES	8
UINT PGPcomdlgPassphraseQuality(LPSTR szPhrase)
{
	UINT quality;
	unsigned short charIndex, rangeIndex, span;
	typedef struct ScoreStruct
	{
		unsigned char firstChar;
		unsigned char lastChar;
	} Range;
	static Range sRanges[] =
	{
		{ 0,		' ' - 1},
		{ ' ',		'A' - 1},
		{ 'A',		'Z'},
		{ 'Z' + 1,	'a' - 1},
		{ 'a',		'z'},
		{ '0',		'9'},
		{ 'z' + 1,	127},
		{ 128,		255},
	};
	BOOL haveRange[NUMRANGES];

  memset(haveRange,'\0',sizeof(haveRange));
//pgpClearMemory (haveRange, sizeof (haveRange));
	for (charIndex = 1; charIndex < lstrlen (szPhrase); ++charIndex) {
		for (rangeIndex = 0; rangeIndex < NUMRANGES; ++rangeIndex)	{
			UCHAR			theChar;
			Range *			theRange;
			
			theChar		= szPhrase[charIndex];
			theRange	= &sRanges[rangeIndex];

			if (theChar >= theRange->firstChar &&
				theChar <= theRange->lastChar)
			{
				haveRange[rangeIndex] = TRUE;
				break;
			}
		}
	}

	// determine the total span
	span = 0;
	for (rangeIndex = 0; rangeIndex < NUMRANGES; ++rangeIndex) {
		if (haveRange[rangeIndex]) {
			span += (unsigned short)(1+(sRanges[rangeIndex].lastChar-
				sRanges[rangeIndex].firstChar));
		}
	}

	if (span != 0) {
		double	bitsPerChar	= log (span) / log (2.0);  // base 2 log of span
		ULONG	totalBits	= (ULONG)(bitsPerChar * lstrlen (szPhrase));

		// assume a maximum quality of 128 bits
		quality = (totalBits * 100) / 128;
		if (quality > 100) quality = 100;
	}
	else {
		quality = 0;
	}

	return (quality);
}
//---------------------------------------------------------------------------
__fastcall TPgpPassForm::TPgpPassForm(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------
__fastcall TPgpPassForm::TPgpPassForm(PassMode Mode, TComponent* Owner)
  : TForm(Owner)
{
   HideTypeBox->Checked = true;
   FormMode = Mode;
   Phrase->Color = clWindow;
   Phrase->Font->Color = clWindow;
   Phrase->Clear();
   Cnfirm->Color = clWindow;
   Cnfirm->Font->Color = clWindow;
   Cnfirm->Clear();
   switch (FormMode)
   {
      case mSecureModePhrase:
         Caption = "Secure Mode";
         Label2->Caption = "&Enter passphrase for encryption : ";
         CancelBtn->Visible = OkBtn->Visible = Phrase->Visible = ClearModeBtn->Visible =
            Cnfirm->Visible = Label2->Visible = Label3->Visible = QualityBox->Visible =
            HideTypeBox->Visible = true;
         CancelBtn->Top = OkBtn->Top = ClearModeBtn->Top = 209;
         Label2->Top = HideTypeBox->Top = 66;
         QualityBox->Top = 12;
         Label3->Top = 136;
         Phrase->Top = 85;
         Cnfirm->Top = 152;
         Height = 269;
         ActiveControl = Phrase;
         break;
      case mConventionalPhrase:
         Caption = "Passphrase for Conventional Encryption";
         Label2->Caption = "&Enter passphrase for encryption :";
         CancelBtn->Visible = OkBtn->Visible = Phrase->Visible = Cnfirm->Visible =
            Label2->Visible = Label3->Visible = QualityBox->Visible =
            HideTypeBox->Visible = true;
         Label2->Top = HideTypeBox->Top = 66;
         CancelBtn->Top = OkBtn->Top = 209;
         QualityBox->Top = 12;
         Label3->Top = 136;
         Phrase->Top = 85;
         Cnfirm->Top = 152;
         Height = 269;
         ActiveControl = Phrase;
         break;
      case mSignKeyPhrase:
         Caption = "PGP Signing Passphrase";
         Label2->Caption = "&Enter passphrase for above key :";
         Keyid->Visible = Label2->Visible = Label1->Visible = CancelBtn->Visible =
            OkBtn->Visible = Phrase->Visible = HideTypeBox->Visible = true;
            //ClearSignBox->Visible = true;
         Label2->Top = HideTypeBox->Top = 62;
         CancelBtn->Top = OkBtn->Top = 135;
         //ClearSignBox->Top = 137;
         Phrase->Top = 80;
         Label1->Top = 15;
         Keyid->Top = 32;
         Height = 192;
         ActiveControl = Phrase;
         break;
      case mSecretKeyPhrase:
         Caption = "PGP Secret Key Passphrase";
         Label2->Caption = "&Please enter your passphrase:";
         Label4->Visible = Label2->Visible = CancelBtn->Visible =
            SecretKeyList->Visible = OkBtn->Visible = Phrase->Visible =
            HideTypeBox->Visible = SaveClearBox->Visible = true;
         Label2->Top = HideTypeBox->Top = 88;
         CancelBtn->Top = OkBtn->Top = 163;
         Phrase->Top = 106;
         Label4->Top = 14;
         SecretKeyList->Top = 32;
         Height = 225;
         SaveClearBox->Checked = GetAppIni(SaveMsgClear,"").ToIntDef(0);
         SaveClearBox->Top = 165;
         ActiveControl = Phrase;
         break;
      case mDecryptionPhrase:
         Caption = "PGP Enter Passphrase";
         Label2->Caption = "&Enter passphrase for decryption :";
         CancelBtn->Visible = OkBtn->Visible = Phrase->Visible = Label2->Visible =
            SaveClearBox->Visible = HideTypeBox->Visible = true;
         Label2->Top = HideTypeBox->Top = 8;
         CancelBtn->Top = OkBtn->Top = 85;
         Phrase->Top = 30;
         Height = 145;
         SaveClearBox->Checked = GetAppIni(SaveMsgClear,"").ToIntDef(0);
         SaveClearBox->Top = 88;
         ActiveControl = Phrase;
         break;
   }
   if (Owner)
   {
      Position = poDesigned;
      CenterDialog(this,(TForm*)Owner);
   }
   bkbrush = new TBrush();
   bkbrush->Color = clWindow;
}
//---------------------------------------------------------------------------
__fastcall TPgpPassForm::~TPgpPassForm()
{
   delete bkbrush;
   ClearText();
}
//---------------------------------------------------------------------------
void __fastcall TPgpPassForm::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ModalResult==mrOk)
   {
      switch (FormMode)
      {
         case mSecureModePhrase:
         case mConventionalPhrase:
            if (Phrase->Text.IsEmpty() && Cnfirm->Text.IsEmpty())
            {
               MessageBox(Handle,"You must enter a passphrase or click on \"Cancel\".","PGP Warning",MB_OK);
               CanClose = false;
            }
            else
            if (Phrase->Text.IsEmpty() || Cnfirm->Text.IsEmpty())
            {
               MessageBox(Handle,"Passphrase entries do not match. Please try again.","PGP Warning",MB_OK);
               CanClose = false;
            }
            break;
         case mSignKeyPhrase:
            if (Phrase->Text.IsEmpty() || Keyid->Text.IsEmpty())
            {
               MessageBox(Handle,
                  s("You must select a signing key AND enter a passphrase\nor click on \"Cancel\".").c_str(),
                  "QS PGP",MB_OK);
               CanClose = false;
            }
            break;
      }
      if (!CanClose) ClearText();
   }
}
//---------------------------------------------------------------------------
void __fastcall TPgpPassForm::FormDestroy(TObject *Sender)
{
   ClearText();
}
//---------------------------------------------------------------------------
void __fastcall TPgpPassForm::ClearText()
{
   for (int i=1; i<=Phrase->Text.Length(); i++) Phrase->Text[i] = '\0';
   Phrase->Clear();
}
//---------------------------------------------------------------------------
void __fastcall TPgpPassForm::PhraseChange(TObject *Sender)
{
   ProgressBar1->Position = (WORD)PGPcomdlgPassphraseQuality(Phrase->Text.c_str());
}
//---------------------------------------------------------------------------
void __fastcall TPgpPassForm::HideTypeBoxClick(TObject *Sender)
{
   Phrase->Font->Color = HideTypeBox->Checked ? clWindow : clBlack;
   Cnfirm->Font->Color = Phrase->Font->Color;
}
//---------------------------------------------------------------------------
void __fastcall TPgpPassForm::FormShow(TObject *Sender)
{
   HideTypeBoxClick(0);
}
//---------------------------------------------------------------------------
void __fastcall TPgpPassForm::ClearModeBtnClick(TObject *Sender)
{
   if (MessageBox(Handle,
         "You have asked to remove password encryption from your QS database\n\nAre you sure?",
         "Cancel Secure Mode",MB_YESNO)==IDYES)
   {
      ModalResult = mrAbort;
   }
}
//---------------------------------------------------------------------------
void __fastcall TPgpPassForm::SaveClearBoxClick(TObject *Sender)
{
   PutAppIni(SaveMsgClear, SaveClearBox->Checked ? "1":"0");
}
//---------------------------------------------------------------------------
void __fastcall TPgpPassForm::SecretKeyListDrawItem(TWinControl *Control,
  int Index, TRect &Rect, TOwnerDrawState State)
{
   TRect r(Rect);
   TListBox *skl = SecretKeyList;
   TCanvas *canvas = skl->Canvas;
   if (canvas->Brush->Color!=clWindow)
   {
      canvas->Font->Color = clWindowText;
      canvas->Brush->Color = clWindow;
   }

   AnsiString userid,keyid,line = skl->Items->Strings[Index];
   int pos=line.Pos("0x");
   userid = pos==1 ? s("") : line.SubString(1,pos-1);
   keyid  = pos==1 ? line.SubString(1,10) : line.SubString(pos,10);

   pos = skl->Items->Count>3 ? 228 : 248;
   canvas->FillRect(r); r.Right = r.Left + pos;
   canvas->TextRect(r,r.Left+4, r.Top, userid); r.Left += pos+4; r.Right += pos+4;
   canvas->TextRect(r,r.Left+4, r.Top, keyid);
}
//---------------------------------------------------------------------------
